<?php
    $lite = isset($_GET["lite"]);

    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;

    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;

        require_once("lib/frole.php");
    $role = new Role();

$role->isPageEnable($user->uuid);

?>
<!doctype html>

<html lang="ru">
<head>
  <meta charset="utf-8" />
  <title>Просмотр всех данных</title>
  <link rel="stylesheet" href="/css/jquery-ui.css" />

  <script src="/js/jquery-1.9.1.js"></script>
  <script src="/js/jquery-ui.js"></script>
  <script src="/js/jquery.form.js"></script>


  <link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
  <script src="/js/bootstrap.min.js"></script>


  <link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
  <link rel="stylesheet" href="/css/admin.css" />
  <link rel="stylesheet" href="/css/navigation__horizontal.css" />

  <link rel="stylesheet" href="/css/overview.table.css" />
  <script src="/js/overview.table.js"></script>

  <script src="/js/auth.js"></script>

  <style>

  .main-page__content {
      margin-top: 60px;
      font-size: 2em;
      text-align: center;
  }

  </style>

  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";

  </script>
</head>

<body>

<header class="header">

<div class="userbox userbox_parent_header">
<?php
    $formName = "userbox";
    $form = new Form($formName);
    $form->configure(array(
        "prevent" => array("jQuery","jQueryUI","bootstrap")
        , "method" => "post"
        , "ajax" => 1
        , "ajaxCallback" => "parseAuthResponse"
        , "novalidate" => "1"
        , "action" => "/auth.php"
        , "class" => "userbox__logout-wrapper"
        , "view" => new View\Inline()
    ));

    $form->addElement(new Element\Hidden("form", $formName));
    $form->addElement(new Element\Hidden("act", "logout"));
    $form->addElement(new Element\HTML('<div class="userbox__logout">'));
    $form->addElement(new Element\Button('Выйти', "submit"));
    $form->addElement(new Element\HTML('</div>'));
    $form->render();
?>

    <div class="userbox__photo userbox__photo_source_loading">&nbsp;</div>
    <div class="userbox__username">
        <span class="userbox__username__displayname"></span>
        <span class="userbox__username__login" title="<?=$user->uuid?>">
            <?=$user->login?>
        </span>
    </div>
    <div class="userbox__helper"></div>
</div>

</header>


<?php $this->renderNavigation(); ?>


<?php if ($mode == self::MODE_NONE): //main page ?>
<div class="main-page">
    <h1 class="main-page__heading">Главная страница</h1>
    <div class="main-page__content">Выберите категорию для обзора статистики</div>
</div>
<?php die; endif; ?>


<?php if ($mode == self::MODE_CLASS && !$currentPageType): ?>
<div class="not-found">
  <h1>Страница не найдена</h1>
  <p>Документ удален или еще не создан</p>

  <p><a href="?">Главная страница</a> | <a href="javascript:history.go(-1);">Вернуться назад</a></p>

  <div class="not-found__create-button">
    <?php ?>
  </div>
</div>
<?php die; endif; ?>



<?php if (!$currentPageType->isPermitted($user->uuid, "overview")): ?>
<div id="forbidden" class="forbidden">
  <h1>Доступ не разрешен</h1>
  <p>Отсутствует разрешение на просмотр всех данных</p>

  <p><a href="?">Главная страница</a> | <a href="javascript:history.go(-1);">Вернуться назад</a></p>
</div>
<?php

endif; ?>



<!-- CURRENT PAGE -->
<div class = "left">
	<?php
echo $role->userMenu($user->uuid);
	?>
</div>



<div class="overview">


<div id="overview-table-top-wrapper" style="visibility: hidden;">
  <table class="overview__table overview__table--horizontal overview__table--top" id="overview-table-top"></table>
</div>

<div id="overview-table-left-wrapper" style="visibility: hidden;">
  <table class="overview__table overview__table--horizontal overview__table--left" id="overview-table-left"></table>
</div>

<div id="overview-table-top-left-wrapper" style="visibility: hidden;">
  <table class="overview__table overview__table--horizontal overview__table--top-left" id="overview-table-top-left"></table>
</div>

<table class="overview__table overview__table--horizontal" id="overview-table">
  <thead>
    <tr>
<?php
    $fields = $currentPageType->items;

    if ($lite) {
      $fields = array_filter($currentPageType->items, function($item) {
          return in_array($item["name"], array("title", "uuid", "visited", "confirmed", "index_code"));
        });
    }

   $cells = "";

    $title_cell = "";
    $report_cell = "";
    $confirmed_cell = "";
    $visited_cell = "";

    foreach ($fields as $ovItem) {
        $ovItemName = $ovItem["name"];

        $labelVar = "label_" . $language;
        $ovItemLabel = $ovItem[$labelVar];

        $indexCodeVar = "index_code_" . $language;
        $ovItemIndexCode = $ovItem[$indexCodeVar];

        $cell = '<td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">'
                    . '<br/>'
                    . $ovItemIndexCode
                    . '<br/><br/>'
                    // . $ovItemName . '<br/><br/>'
                    . $ovItemLabel
                    . (isset($ovItem["accumulative"]) ? (''
                        . '<br/><br/>'
                        . '<i>'
                        . ($ovItem["accumulative"] ? 'накопительное' : '')
                        . '</i>'
                        . '') : '')
                . "</td>";

        if ($ovItemName == "uploaded") {
            continue;
        }
        if ($ovItemName == "url") {
            continue;
        }
        if ($ovItemName == "title") {
            $title_cell = $cell;
            continue;
        }
        if ($ovItemName == "chairtype") {
            continue;
        }
        if ($ovItemName == "report") {
            $report_cell = $cell;
            continue;
        }
        if ($ovItemName == "confirmed") {
            $confirmed_cell = $cell;
            continue;
        }
        if ($ovItemName == "visited") {
            $visited_cell = $cell;
            continue;
        }
        if ($ovItemName == "uuid") {
            continue;
        }
        if ($ovItemName == "parent") {
            continue;
        }
        if ($ovItemName == "url2") {
            continue;
        }
        if ($ovItemName == "uploaded2") {
            continue;
        }
        // $cells .= $cell;
    }

    $cells = ''
           . $title_cell
           . $visited_cell
           . $confirmed_cell
           . $cells;

    echo $cells;
?>
    </tr>
  </thead>
  <tbody>
<?php
    $ovDocuments = Document::find($mn, $prefix, $currentPageType->type);

    $since = new \DateTime("2013-12-28");
    $till = null;

    function prepareValue($name, $value, $version = null) {
      $divClass = "";
      if (in_array($name, ["confirmed", "visited"])) {
          $glyphTrue = 'glyphicon-ok icon-ok';
          $glyphFalse = 'glyphicon-remove icon-remove';
          $textTrue = '';
          $textFalse = '';

          if ($name == "visited") {
              $glyphTrue = 'glyphicon-eye-open icon-eye-open';
              $glyphFalse = 'glyphicon-eye-close icon-eye-close';
          }

          $cellValue = ''
              . '<span class="label '
                  . ($value
                      ? 'label-success'
                      : 'label-important'
                      )
                  . '">'

                  . '<i class="glyphicon '
                      . ($value
                          ? $glyphTrue
                          : $glyphFalse
                          )
                  . '"></i>'

                  . ' '

                  . ($value
                      ? $textTrue
                      : $textFalse
                      )

              . '</span>'
              . ' '
              . (isset($version)
                  ? (isset($version["label_ru"]) ? $version["label_ru"] : ((isset($version["datetime"]) ? date("r", $version["datetime"]->sec) : 'Дата не указана')))
                  : 'Последний этап')
              . '';

          if ($value) {
              // $divClass = "label label-success";
          } else {
              // $divClass = "label label-danger";
          }
      } else {
          $cellValue = $value;
      }

      return ''
          // . ($version ? '<td>' : '')
          . '<div style="display: inline: block; text-align: left; margin-left: 2px;" '
            . ' class="' . $divClass . '"'
          . '>'
              . ($version
                  ? ('<i class="old-value" title="' . (isset($version["datetime"]) ? date("r", $version["datetime"]->sec) : 'Дата не указана') . '">')
                  : '')

                  . $cellValue

                  . ($version
                      ? ' — ' . (isset($version["datetime"]) ? date("d.m.Y", $version["datetime"]->sec) : 'Нет даты')
                      : '')

              . ($version
                  ? '</i>'
                  : '')
          . '</div>'
          // . ($version ? '</td>' : '')

          . '';
    }

    $rows = "";
    foreach ($ovDocuments as $ovDocument) {
        if (!$ovDocument->isPermitted($user->uuid, "overview")) {
            continue;
        }

        $docConfirmed = $ovDocument->getFieldI18nValue("confirmed");
        $docVisited = $ovDocument->getFieldI18nValue("visited");

        $versions = $ovDocument->findVersions($since, $till);

        $versions = array_reverse($versions);

        $row = "";
        $row .= '<tr>';

        $cells = "";

        $title_cell = "";
        $report_cell = "";
        $confirmed_cell = "";
        $visited_cell = "";

        foreach ($fields as $ovItem) {
            $labelVar = "label_" . $language;
            $ovItemLabel = $ovItem[$labelVar];
            $ovItemName = $ovItem["name"];
            $ovItemI18nName = (isset($ovItem["no_i18n"]) && $ovItem["no_i18n"]) ? ($ovItemName) : ($ovItemName . "_" . $language);
            $ovItemValue = isset($ovDocument->fields[$ovItemI18nName]) ? $ovDocument->fields[$ovItemI18nName] : "";

            if (!is_scalar($ovItemValue)) {
                $ovItemValue = "...";
            }

            $versionContent = implode('', array_map(function($version) use ($ovItemName, $ovItemI18nName) {
                      if (!isset($version["datetime"])) {
                          if (!isset($_GET["debug"])) {
                              return;
                          }
                      }
                      $content = isset($version["content"]) ? $version["content"] : array();
                      if (isset($content[$ovItemI18nName])) {
                          return prepareValue($ovItemName, $content[$ovItemI18nName], $version);
                      }
                  }, $versions));

            if (!empty($versionContent)) {
              $versionContent = ''
                                // . '<table>'
                                // . '<tbody>'
                                // . '<tr>'
                                . $versionContent
                                // . '</tr>'
                                // . '</tbody>'
                                // . '</table>'
                                . '';
            }

            $cell = '<td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">'
                        // . '[' . $ovItemName . ']' . '<br/>'

                        . prepareValue($ovItemName, $ovItemValue)

                        . (!empty($versionContent) ? "<br/>" : "")

                        . (!empty($versionContent) ? $versionContent : '')


                . "</td>";

            if ($ovItemName == "title") {
                $title_cell = $cell;
                continue;
            }
            if ($ovItemName == "uploaded") {
                continue;
            }
            if ($ovItemName == "url") {
                continue;
            }
            if ($ovItemName == "uploaded2") {
                continue;
            }
            if ($ovItemName == "url2") {
                continue;
            }
            if ($ovItemName == "report") {
                // $report_cell = '<td class="overview-table-cell-' . $ovItemName . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no') . '" data-item="' . $ovItemName . '">' . ($ovItemValue ? '<i class="glyphicon glyphicon-ok-sign icon-ok-sign"></i> ' : '') . '</td>';
                continue;
            }
            if ($ovItemName == "confirmed") {
                $confirmed_cell = $cell;
                // $confirmed_cell = '<td class="overview-table-cell-' . $ovItemName . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no') . '" data-item="' . $ovItemName . '">' . ($ovItemValue ? '<i class="glyphicon glyphicon-ok-sign icon-ok-sign"></i> ' : '') . '</td>';
                continue;
            }
            if ($ovItemName == "visited") {
                $visited_cell = $cell;
                // $visited_cell = '<td class="overview-table-cell-' . $ovItemName . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no') . '" data-item="' . $ovItemName . '">' . ($ovItemValue ? '<i class="glyphicon glyphicon-ok-sign icon-ok-sign"></i> ' : '') . '</td>';
                continue;
            }
            if ($ovItemName == "chairtype") {
                continue;
            }
            if ($ovItemName == "uuid") {
                continue;
            }
            if ($ovItemName == "parent") {
                continue;
            }
            // $cells .= $cell;
        }

        $cells = ''
               . $title_cell
               . $visited_cell
               . $confirmed_cell
               . $cells;

        $row .= $cells;

        $row .= '</tr>';

        $rows .= $row;
    }

    echo $rows;
?>
  </tbody>
</table>

</div>

</body>
</html>
